require "defines"

oneshot = {
}

require "config"


function oneshot.update_players(event)
    local update = event.tick % oneshot.ticks_between_checks
    if not update == 0 then return end

    for _, force in pairs(game.forces) do
        if global.has_tech[force.name] then
            -- update all players in the force
            for _, player in pairs(force.players) do
                -- go over each filter slot in the inventory
                for i=1,5 do
                    local stack = player.character.get_request_slot(i)
                    if stack ~= nil and stack.count > 0 then
                        -- tally the inventories for this item.
                        if player.get_item_count(stack.name) >= stack.count then
                            player.print("Request for " .. stack.count .. " " .. stack.name .. " completed.")
                            player.character.clear_request_slot(i)
                        end
                    end
                end
            end
        end
    end
end


function oneshot.on_research_finished(event)
    local tech = event.research
    msg_all("Tech " .. tech.name .. " was researched by " .. tech.force.name)
    if tech.name == "one-shot-logistics" then
        global.has_tech[tech.force.name] = true

    end
end

function oneshot.on_force_created(event)
    if not global.has_tech then global.has_tech = {} end
    global.has_tech[event.force.name] = false
end

function oneshot.on_tick(event)
    if not global.has_tech then global.has_tech = {} end
    oneshot.update_players(event)
end